/******************************************************************************
CLASSE FRMESTUDOS
CRIADO: 21-10-2008
ALTERADO: 15-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#include "frmestudos.h"

#include "exportar.h"

FrmEstudos::FrmEstudos():FrmBase(){
	setWindowTitle("Estudos - " + (const QString&)NOME);
	setMinimumSize( QSize( 390, 320 ) );
	resize(390, 320);

	fonte = QFont("Bitstream", FONTE_MEDIA);
	boxEstudos = new QGroupBox( "boxEstudos", this );
	boxEstudos->setTitle("Estudos Bblicos");
	boxEstudos->setFont(fonte);

	BancoUser bancoUser;

	fonte = QFont("Bitstream", FONTE_PEQUENA);
	lblCategoriaEstudos = new QLabel("Categoria", boxEstudos);
	lblCategoriaEstudos->setFont(fonte);
	lblCategoriaEstudos->setAlignment( Qt::AlignLeft );
	lblCategoriaEstudos->setWordWrap(true);

	lblTituloEstudos = new QLabel("Ttulo", boxEstudos);
	lblTituloEstudos->setFont(fonte);
	lblTituloEstudos->setAlignment( Qt::AlignLeft  );
	lblTituloEstudos->setWordWrap(true);

	fonte = QFont("Bitstream", FONTE_MEDIA);
	cbxCategoria = new QComboBox( boxEstudos );
	cbxCategoria->setFont(fonte);
	cbxCategoria->setToolTip("Categorias de estudos existentes");

	cbxTitulo = new QComboBox( boxEstudos );
	cbxTitulo->setFont(fonte);
	cbxTitulo->setToolTip("Ttulos de estudos da\ncategoria selecionada");

	btnExportar = new QPushButton( boxEstudos );
	btnExportar->setText("Exportar");
	btnExportar->setFont(fonte);
	btnExportar->setToolTip("Exportar o estudo selecionado");

	btnExcluir = new QPushButton( boxEstudos );
	btnExcluir->setText("Excluir");
	btnExcluir->setFont(fonte);
	btnExcluir->setToolTip("Excluir o estudo selecionado");

	btnEditar = new QPushButton( boxEstudos );
	btnEditar->setText("Editar");
	btnEditar->setFont(fonte);
	btnEditar->setToolTip("Editar o estudo selecionado");

	btnLer = new QPushButton( boxEstudos );
	btnLer->setText("Ler");
	btnLer->setFont(fonte);
	btnLer->setDefault(true);
	btnLer->setToolTip("Ler o estudo selecionado");
	
	fonte = QFont("Bitstream", FONTE_PEQUENA);
	chkExcluirTudo = new QCheckBox("Excluir tudo", boxEstudos);
	chkExcluirTudo->setFont(fonte);
	chkExcluirTudo->setToolTip("Excluir todos os estudos");
	
	fonte = QFont("Bitstream", FONTE_MEDIA);
	boxMaisOpcoes = new QGroupBox( "boxMaisOpcoes", this );
	boxMaisOpcoes->setTitle("Mais opes");
	boxMaisOpcoes->setFont(fonte);

	btnExportarTudo = new QPushButton( boxMaisOpcoes );
	btnExportarTudo->setText("Exportar tudo");
	btnExportarTudo->setFont(fonte);
	btnExportarTudo->setToolTip("Exportar todos os estudos");

	btnImportar = new QPushButton( boxMaisOpcoes );
	btnImportar->setText("Importar");
	btnImportar->setFont(fonte);
	btnImportar->setToolTip("Importar estudos");

	btnCriar = new QPushButton( boxMaisOpcoes );
	btnCriar->setText("Criar");
	btnCriar->setFont(fonte);
	btnCriar->setToolTip("Criar estudo");
	
	btnLinkEstudos = new QPushButton( boxMaisOpcoes );
	btnLinkEstudos->setFont(fonte);
	btnLinkEstudos->setText("Obter estudos");
	btnLinkEstudos->setToolTip("Acessar pgina web para\nbaixar base de estudos");
	
	definirObjetosCancelar();
	
	carregarCombosEstudos();

	connect( btnLer, SIGNAL( clicked () ), this, SLOT(chamarLerEstudos() ) );
	connect( btnEditar, SIGNAL( clicked () ), this, SLOT(chamarEditarEstudos() ) );
	connect( btnExcluir, SIGNAL( clicked () ), this, SLOT(chamarExcluirEstudos() ) );
	connect( btnExportar, SIGNAL( clicked () ), this, SLOT(chamarExportarUmEstudo() ) );
	connect( chkExcluirTudo, SIGNAL( clicked () ), this, SLOT(slotChkExcluirTudo() ) );
	connect( btnCriar, SIGNAL( clicked () ), this, SLOT(chamarCriarEstudos() ) );
	connect( btnImportar, SIGNAL( clicked () ), this, SLOT(chamarImportarEstudos() ) );
	connect( btnExportarTudo, SIGNAL( clicked () ), this, SLOT(chamarExportarEstudos() ) );
	connect( btnLinkEstudos, SIGNAL( clicked() ), this, SLOT(carregarLinkEstudos() ) );
	connect( cbxCategoria, SIGNAL( activated (const QString&) ), this, SLOT(carregarTituloEstudos() ) );
}

//Estudos
void FrmEstudos::chamarLerEstudos(){
	qApp->setOverrideCursor( Qt::WaitCursor );
	ReadEstudos* wgtEstudos = new ReadEstudos(cbxCategoria->currentText(), cbxTitulo->currentText(), "l");
	qApp->restoreOverrideCursor();
	wgtEstudos->setParent(this->parentWidget(), Qt::Window);
	emit novaJanela(wgtEstudos);
	if (chkFecharAlto->isChecked())
		close();
}
void FrmEstudos::chamarEditarEstudos(){
	qApp->setOverrideCursor( Qt::WaitCursor );
	ReadEstudos* wgtEstudos = new ReadEstudos(cbxCategoria->currentText(), cbxTitulo->currentText(), "e");
	qApp->restoreOverrideCursor();
	wgtEstudos->setParent(this->parentWidget(), Qt::Window);
	emit novaJanela(wgtEstudos);
	if (chkFecharAlto->isChecked())
		close();
}
void FrmEstudos::chamarExcluirEstudos(){
	AMessageBox aMsgBox;
	BancoUser bancoUser;
	if (!chkExcluirTudo->isChecked()){
		if (aMsgBox.yesNo("Tem certeza que deseja excluir este estudo?","Excluir estudo")){
			qApp->setOverrideCursor( Qt::WaitCursor );
			bancoUser.delEstudo(cbxCategoria->currentText(),cbxTitulo->currentText());
			emit fecharEstudos(cbxCategoria->currentText(),cbxTitulo->currentText());
			carregarCombosEstudos();
			qApp->restoreOverrideCursor();
		}
	}
	else {
		if (aMsgBox.yesNo("Tem certeza que deseja excluir toda a base de estudos?","Excluir estudo")){
			qApp->setOverrideCursor( Qt::WaitCursor );
			bancoUser.delEstudo("","");
			emit fecharEstudos("","");
			carregarCombosEstudos();
			qApp->restoreOverrideCursor();
		}
	}
}
void FrmEstudos::chamarExportarUmEstudo(){
	QString file = QFileDialog::getSaveFileName(this, tr("Salvar arquivo"), config.getDirHome(), tr("*.abe"));
	if (!file.isEmpty()){
		QFileInfo fi(file);
		config.setDirHome(fi.absoluteDir().path());
	
		if (!file.contains(".abe"))
			file += ".abe";
		QFile f(file);
		if (f.exists())
			f.remove();
		Exportar exp(file);
		qApp->setOverrideCursor( Qt::WaitCursor );
		exp.exportarUmEstudo(cbxCategoria->currentText(), cbxTitulo->currentText());
		qApp->restoreOverrideCursor();
	}
}
void FrmEstudos::chamarCriarEstudos(){
	qApp->setOverrideCursor( Qt::WaitCursor );
	ReadEstudos* wgtEstudos = new ReadEstudos("", "", "c");
	qApp->restoreOverrideCursor();
	wgtEstudos->setParent(this->parentWidget(), Qt::Window);
	emit novaJanela(wgtEstudos);
	if (chkFecharAlto->isChecked())
		close();
}
void FrmEstudos::chamarImportarEstudos(){
	QString file = QFileDialog::getOpenFileName(this, tr("Abrir arquivo"), config.getDirHome(), tr("*.abe"));
	if (!file.isEmpty()){
		QFileInfo fi(file);
		config.setDirHome(fi.absoluteDir().path());
		
		Exportar imp(file);
		qApp->setOverrideCursor( Qt::WaitCursor );
		if (imp.importarEstudos())
			carregarCombosEstudos();
		qApp->restoreOverrideCursor();
	}
}
void FrmEstudos::chamarExportarEstudos(){
	QString file = QFileDialog::getSaveFileName(this, tr("Salvar arquivo"), config.getDirHome(), tr("*.abe"));
	if (!file.isEmpty()){
		QFileInfo fi(file);
		config.setDirHome(fi.absoluteDir().path());
		
		if (!file.contains(".abe"))
			file += ".abe";
		QFile f(file);
		if (f.exists())
			f.remove();
		Exportar exp(file);
		qApp->setOverrideCursor( Qt::WaitCursor );
		exp.exportarEstudos();
		qApp->restoreOverrideCursor();
	}
}
void FrmEstudos::slotChkExcluirTudo(){
	if (chkExcluirTudo->isChecked()){
		AMessageBox aMsgBox;
		aMsgBox.ok("Voc habilitou a excluso de toda a base de estudos.\n"
		"Acionar o boto Excluir com essa opo habilitada ir excluir todos "
		"os seus estudos!", "Excluir todos os estudos");
		btnExcluir->setToolTip("Excluir todos os estudos");
	}
	else
		btnExcluir->setToolTip("Excluir o estudo selecionado");
}
void FrmEstudos::carregarTituloEstudos(){
	BancoUser bancoUser;
	cbxTitulo->clear();
	cbxTitulo->addItems(bancoUser.getTitulosEstudo(cbxCategoria->currentText()));
}
void FrmEstudos::carregarCombosEstudos(){
	BancoUser bancoUser;
	cbxCategoria->clear();
	cbxTitulo->clear();
	cbxCategoria->addItems(bancoUser.getCategoriasEstudo());
	cbxTitulo->addItems(bancoUser.getTitulosEstudo(cbxCategoria->currentText()));
	
	if (cbxCategoria->currentText().trimmed().isEmpty()){
		cbxCategoria->setEnabled(false);
		cbxTitulo->setEnabled(false);
		btnLer->setEnabled(false);
		btnEditar->setEnabled(false);
		btnExcluir->setEnabled(false);
		chkExcluirTudo->setEnabled(false);
		btnExportar->setEnabled(false);
		btnExportarTudo->setEnabled(false);
	}
	else{
		cbxCategoria->setEnabled(true);
		cbxTitulo->setEnabled(true);
		btnLer->setEnabled(true);
		btnEditar->setEnabled(true);
		btnExcluir->setEnabled(true);
		chkExcluirTudo->setEnabled(true);
		btnExportar->setEnabled(true);
		btnExportarTudo->setEnabled(true);
	}
}
void FrmEstudos::carregarLinkEstudos(){
	QUrl url("http://www.comunidadeabiblia.net/abiblia/estudos");
	QDesktopServices::openUrl ( url );
}

void FrmEstudos::resizeEvent(QResizeEvent * /*event*/){
	unsigned short int extraWidth = width() - minimumWidth();
	unsigned short int extraHeight = height() - minimumHeight();

	boxEstudos->setGeometry( QRect( 10, 10, 370 + extraWidth, 180 + extraHeight/2) );
	lblCategoriaEstudos->setGeometry( QRect( 140, 30, 370 + extraWidth, 25 ) );
	cbxCategoria->setGeometry( QRect( 140, 45, 220 + extraWidth, 25 ) );
	lblTituloEstudos->setGeometry( QRect( 10, 70, 330, 25 ) );
	cbxTitulo->setGeometry( QRect( 10, 85, 350 + extraWidth, 25 ) );
	btnExportar->setGeometry( QRect( 10 + extraWidth, 120, 70, 25 ) );
	btnExcluir->setGeometry( QRect( 90 + extraWidth, 120, 70, 25 ) );
	btnEditar->setGeometry( QRect( 170 + extraWidth, 120, 70, 25 ) );
	btnLer->setGeometry( QRect( 290 + extraWidth, 120, 70, 25 ) );
	chkExcluirTudo->setGeometry( QRect( 10 + extraWidth, 150, 180, 25 ) );
	
	boxMaisOpcoes->setGeometry( QRect( 10, 200 + extraHeight/2, 370 + extraWidth, 70 + extraHeight/2) );
	btnLinkEstudos->setGeometry( QRect( 10 + extraWidth, 30, 90, 25 ) );
	btnExportarTudo->setGeometry( QRect( 110 + extraWidth, 30, 90, 25 ) );
	btnImportar->setGeometry( QRect( 210 + extraWidth, 30, 70, 25 ) );
	btnCriar->setGeometry( QRect( 290 + extraWidth, 30, 70, 25 ) );
	
	btnCancelar->setGeometry( QRect( width() - 80, height() - 35, 70, 25 ) );
	chkFecharAlto->setGeometry( QRect( 10, height() - 30, 200, 25) );
}

