/******************************************************************************
HEADER DA CLASSE READBIBLIA
CRIADO: 28-05-2008
ALTERADO: 16-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#ifndef READBIBLIA_H
#define READBIBLIA_H

#include <QtGui>

#include "readbiblico.h"
#include "const.h"
#include "config.h"
#include "resolucao.h"
#include "bancouser.h"
#include "bancosystem.h"
#include "amessagebox.h"

class QPixmap;
class QLabel;
class QFont;
class QTextEdit;
class QPushButton;
class BancoUser;
class BancoSystem;

class ReadBiblia : public ReadBiblico
{
   Q_OBJECT

public:
	ReadBiblia(const QString &strLivroCapitulo, short int idTestamento);
	~ReadBiblia();
	
	//Menus
	QAction *salvarAnot;
	QAction *recarregarAnot;
	QAction *limparAnot;

	//Caixa de texto Rodap
	QTextEdit *caixaTextoRodape;
	QLabel *anotacoes;
	QFont fonteAnotacoes;

	//Combos Ler Bblia
	QTabWidget* tabWidgetCombo;
	QWidget* boxComboPadrao;
	QToolButton* btnComboLeitura;
	QLabel *lblAntTestamento;
	QLabel *lblNovoTestamento;
	QComboBox* cbxCapituloNovoTestamento;
	QComboBox* cbxLivroNovoTestamento;
	QPushButton* btnLerNovoTestamento;
	QPushButton* btnLerAntTestamento;
	QComboBox* cbxCapituloAntTestamento;
	QComboBox* cbxLivroAntTestamento;
	
	QWidget* boxComboBasico;
	QGroupBox* boxLivro;
	QPushButton* btnLivroProximo;
	QPushButton* btnLivroAnterior;
	QGroupBox* boxCapitulo;
	QPushButton* btnCapituloProximo;
	QPushButton* btnCapituloAnterior;

	QString strRodape;
	QString strAnotacoes;
	bool comboLeitura;

	QString getLivroCapitulo();
	int getIdTestamento();
	void setTexto(const QString& strLivroLocal, const QString& strCapituloLocal, short int idTestamento);
	void carregarLivroProxAnt(short int idOperacao, short int idTestamento);
	void carregarCapituloProxAnt(short int idOperacao, short int idTestamento);
	void habilitarBotoesBasico();
	void instanciarComboBiblia();
	void setModoComboLeitura();
	void setLivroCapituloInicialComboBiblia(short int idTestamento);
	void liberarMemoria();
	
private:
	QString _strLivroCapitulo;
	int _idTestamento;
	void resizeRodape();
	void resizeEvent(QResizeEvent * /*event*/);

public slots:
	void carregarLivroVelho();
	void carregarCapituloVelho();
	void carregarLivroNovo();
	void carregarCapituloNovo();
	void carregarLivroProximo();
	void carregarLivroAnterior();
	void carregarCapituloProximo();
	void carregarCapituloAnterior();
	void ordemBiblica();
	void setVelhoDefault();
	void setNovoDefault();
	void slotGetComboLeitura();
	void slotSetComboLeitura();
	void carregarCapitulo(const QString &livro, short int idTestamento);
	void slotRecarregaCaixaRodape();
	void slotSalvaCaixaRodape();
	void slotModificado();
	void slotZoomIn();
	void slotZoomOut();
	void slotZoomDefault();
	//void slotVerificarConteudo();
	QString carregarTexto(const QString &strLivroCapitulo, short int idTestamento, bool secundario);
};
#endif

